routes/web.php
<?php

use App\Http\Controllers\AirportsController;
use App\Http\Controllers\BooksController;
use App\Http\Controllers\HomeController;
use App\Http\Controllers\UsersController;
use App\Http\Controllers\ContactController;
use App\Http\Controllers\MainController;
use Illuminate\Support\Facades\Route;
use App\Http\Controllers\FlightController;


/*
|--------------------------------------------------------------------------
| Web Routes
|--------------------------------------------------------------------------
|
| Here is where you can register web routes for your application. These
| routes are loaded by the RouteServiceProvider within a group which
| contains the "web" middleware group. Now create something great!
|
*/

Route::get('/', [MainController::class, "mainpage"])->name('main');
Route::get('/singleflight/{id}', [MainController::class, "singleflight"])->name('singleflight');
Route::get('book/singleflight/{id}', [MainController::class, "bookflight"])->middleware(['auth'])->name('bookflight');
Route::post('bookFlight/{flightId}&{passengerId}', [MainController::class, "confirmBooking"])->middleware(['auth'])->name('confirmBooking');

Route::get('/books', [BooksController::class, 'list'])->middleware(['auth'])->name('list');

Route::get('/contact', [ContactController::class, 'contactform'])->name('contact');
Route::post('/contact', [ContactController::class, 'sendcontactform'])->name('contact.store');

Route::get('/dashboard', function () {
    return view('dashboard');
})->middleware(['auth'])->name('dashboard');

Route::get('/termsofuse', function () {
    return view('termsofuse');
})->name('termsofuse');

Route::get('/privacy', function () {
    return view('privacy');
})->name('privacy');

Route::get('/admin', [HomeController::class, 'redirect'])->middleware('admin')->name('admin.home');

Route::get('/admin/user',
    [UsersController::class, 'index'])->middleware('admin')->name('admin.user');

Route::get('/admin/airport',
    [AirportsController::class, 'index'])->middleware('admin')->name('admin.airport');

Route::get('/admin/book',
    [BooksController::class, 'index'])->middleware('admin')->name('admin.book');

Route::get('/admin/flight',
    [FlightController::class, 'index'])->middleware('admin')->name('admin.flight');

Route::get('/admin/message',
    [ContactController::class, 'index'])->middleware('admin')->name('admin.message');


//Users
Route::post('/admin/createUser',
    [UsersController::class, 'createUser']
)->middleware(['admin'])->name('admin.createUser');

Route::get('/admin/createUser',
    [UsersController::class, 'create']
)->middleware(['admin'])->name('admin.createUser');

Route::get('/admin/updateUser/{id}',
    [UsersController::class, 'updateUser']
)->middleware(['admin'])->name('admin.updateUser');

Route::post('/admin/updateUser/{id}',
    [UsersController::class, 'saveUser']
)->middleware(['admin'])->name('admin.saveUser');

Route::get('/admin/deleteUser/{id}',
    [UsersController::class, 'deleteUser']
)->middleware(['admin'])->name('admin.deleteUser');

//Airports
Route::get('/admin/createAirport',
    [AirportsController::class, 'create']
)->middleware(['admin'])->name('admin.createAirport');

Route::post('/admin/createAirport',
    [AirportsController::class, 'createAirport']
)->middleware(['admin'])->name('admin.createAirport');

Route::get('/admin/deleteAirport/{id}',
    [AirportsController::class, 'deleteAirport']
)->middleware(['admin'])->name('admin.deleteAirport');

//Flights
Route::get('/admin/createFlight',
    [FlightController::class, 'create']
)->middleware(['admin'])->name('admin.createFlight');

Route::post('/admin/createFlight',
    [FlightController::class, 'createFlight']
)->middleware(['admin'])->name('admin.createFlight');

Route::get('/admin/deleteFlight/{id}',
    [FlightController::class, 'deleteFlight']
)->middleware(['admin'])->name('admin.deleteFlight');

Route::get('/admin/updateFlight/{id}',
    [FlightController::class, 'updateFlight']
)->middleware(['admin'])->name('admin.updateFlight');

Route::post('/admin/updateFlight/{id}',
    [FlightController::class, 'saveFlight']
)->middleware(['admin'])->name('admin.saveFlight');

//Books
Route::get('/admin/deleteBook/{id}',
    [BooksController::class, 'deleteBook']
)->middleware(['admin'])->name('admin.deleteBook');

Route::get('/admin/updateBook/{id}',
    [BooksController::class, 'updateBook']
)->middleware(['admin'])->name('admin.updateBook');

Route::post('/admin/updateBook/{id}',
    [BooksController::class, 'saveBook']
)->middleware(['admin'])->name('admin.saveBook');

/* Routes relative to flight management in front */
Route::get('/flight/list', [FlightController::class, 'list'])->middleware(['verified'])->name('flight.list');
Route::get('/flight/new', [FlightController::class, 'new'])->middleware(['verified'])->name('flight.new');
Route::post('/flight/store', [FlightController::class, 'store'])->middleware(['verified'])->name('flight.store');


require __DIR__ . '/auth.php';

app/View/Components/AppLayout.php
<?php

namespace App\View\Components;

use Illuminate\View\Component;

class AppLayout extends Component
{
    /**
     * Get the view / contents that represents the component.
     *
     * @return \Illuminate\View\View
     */
    public function render()
    {
        return view('layouts.app');
    }
}

app/View/Components/BaseLayout.php
<?php

namespace App\View\Components;

use Illuminate\View\Component;

class BaseLayout extends Component
{
    /**
     * Create a new component instance.
     *
     * @return void
     */
    public function __construct()
    {
        //
    }

    /**
     * Get the view / contents that represent the component.
     *
     * @return \Illuminate\Contracts\View\View|\Closure|string
     */
    public function render()
    {
        return view('layouts.base');
    }
}

resources/views/bookflight.blade.php
<x-base-layout>
    <div class="flex-1 bg-gray-50">
        <div class="flex flex-col mx-auto max-w-7xl gap-2 py-8">
            <h1 class="text-2xl font-semibold">Process reservation</h1>
            <h2>Book Flight Number : {{ $flight->flightNumber }} -  ({{ $flight->price }}€ / sit)</h2>
        
            <h2 class="mt-1">{{ Auth::user()->name }}, fill this form to prepare your Flight :</h2>
            <div>
                <form
                    id="form"
                    action="{{ route('confirmBooking', [
                        'flightId' => $flight->id,
                        'passengerId' => Auth::id()
                    ])}}"
                    method="POST">
                    @csrf

                    <x-auth-validation-errors class="mb-4" :errors="$errors" />
            
                    <div class="grid grid-cols-2 mt-4">
            
                        <div class="flex flex-col gap-2">
                            <label for="passengers">Number of passengers</label>
                            <input name="passengers" id="passengers" type="number" min="0" placeholder="ex : 5">
                            <input type="hidden" id="price" value="{{ $flight->price }}">
                        </div>
            
                    </div>
            
                    <div class="grid grid-cols-2 mt-4">
            
                        <div class="flex flex-col gap-2">
                            <label for="comment">Comment</label>
                            <input name="comment" id="comment" type="text" placeholder="ex : I have a poney with me">
                        </div>
            
                    </div>

                    <div class="grid grid-cols-2 mt-4">
            
                        <div class="flex flex-col gap-2">
                            <label for="card-holder-name">Card holder name</label>
                            <input name="card-holder-name" id="card-holder-name" type="text" >
                        </div>
            
                    </div>

                    <input type="hidden" id="payment_method" name="payment_method">
            
            
                    <div class="grid grid-cols-2 mt-4">
                        <div class="flex flex-col gap-2">
                            <label for="comment">Card number</label>
                            <div  id="card-element"></div>
                        </div>
                    </div>
                    
                    <div class="grid grid-cols-2 mt-4">
                        <div class="flex items-center justify-between mt-4">
                            <p id="amount"> </p>
                            <div class="flex gap-4">
                                <a href="{{ route('main', request()->all() ) }}" class="btn btn-active">Back</a>
                                <button id="card-button" type="button" class="btn">Validade and process payment</button>
                            </div>
                        </div>
                    </div>
            
                </form>
            
                @if ($errors->any())
                    <div class="alert alert-danger">
                        <ul>
                            @foreach ($errors->all() as $error)
                                <li style='color:red;'>{{ $error }}</li>
                            @endforeach
                        </ul>
                    </div>
                @endif
            
            </div>
        </div>
    </div>
<script src="https://js.stripe.com/v3/"></script>
 
<script>

    const passengersNumber = document.getElementById('passengers')
    const amount = document.getElementById('amount')
    const price = parseFloat(document.getElementById('price').value).toFixed(2)

    passengersNumber.addEventListener('change', () => {
        const n = passengersNumber.value ?? 0
        const total = price * n
        console.log(total)
        if(total){
            amount.innerText = 'Total : ' + total.toFixed(2) + ' €'
        } else {
            amount.innerText = ''
        }
    })

    const stripe = Stripe(" {{ env('STRIPE_KEY') }} ");
 
    const elements = stripe.elements();
    const cardElement = elements.create('card', {
        classes: {
            base: 'StripeElement border border-gray-700 bg-white  px-2 py-3'
        }
    });
 
    cardElement.mount('#card-element');

    const cardHolderName = document.getElementById('card-holder-name');

    const cardButton = document.getElementById('card-button');
    
    cardButton.addEventListener('click', async (e) => {
        e.preventDefault()

        const { paymentMethod, error } = await stripe.createPaymentMethod('card', cardElement);
    
        if (error) {
            alert(error)
        } else {
            document.getElementById('payment_method').value = paymentMethod.id
        }

        document.getElementById('form').submit()
    });
</script>
</x-base-layout>

resources/views/books.blade.php
<x-base-layout>

    <div class="container mx-auto">

        <div class="flex items-center justify-between">
            <div class="flex flex-col gap-3">
                <div class="flex justify-between">
                    <h1 class="text-xl">My flights</h1>
                </div>

                <div class="flex items-center gap-3 mt-3">
                    <a class="btn {{ $incoming == 1 ? 'btn-active' : '' }}" href="?incoming=1">Incoming</a>
                    <a class="btn {{ $incoming == 0 ? 'btn-active' : '' }}" href="?incoming=0">Passed</a>
                </div>
            </div>
        </div>

        <table class="table-style mt-3 w-full">
            <thead>
                <th>#</th>
                <th>Inbound</th>
                <th>Inbound datetime</th>
                <th>Outbound</th>
                <th>Outbound datetime</th>
                <th>Comment</th>
                <th>Passengers</th>
            </thead>
            <tbody>
                @foreach (Auth::user()->books($incoming)->get() as $book)
                    <tr>
                        <th class="text-center hover:underline">
                            <a class="" href="#">{{ $book->flight->flightNumber }}</a>
                        </th>
                        <td class="text-center">{{ $book->flight->airport_inbound->country }} - {{ $book->flight->airport_inbound->city }}</td>
                        <td class="text-center">{{ date_create($book->flight->startDateTime)->format('m/d/Y \a\t h:i a') }}</td>
                        <td class="text-center">{{ $book->flight->airport_outbound->country }} - {{ $book->flight->airport_outbound->city }}</td>
                        <td class="text-center">{{ date_create($book->flight->endDateTime)->format('m/d/Y \a\t h:i a') }}</td>
                        <td class="text-center">{{ $book->comment}}</td>
                        <td class="text-center">{{ $book->passengers}}</td>
                    </tr>
                @endforeach
            </tbody>
        </table>

    </div>


</x-base-layout>

resources/views/contact.blade.php
<x-base-layout>
    <div class="flex-1 bg-purple-100">
        <div class="flex flex-col gap-4 max-w-7xl py-8 mx-auto ">
            <h1 class="text-3xl font-semibold">Contact us</h1>

            <div class="bg-white overflow-hidden shadow-sm sm:rounded-lg p-6 bg-white border-b border-gray-200">
                @if (isset($messagevalidation))
                    <p class="mb-4 font-medium text-sm text-green-600">{{ $messagevalidation }}</p>
                @endif
                <!-- Validation Errors -->
                <x-auth-validation-errors class="mb-4" :errors="$errors" />
                <form id="contact-form" class="flex flex-col gap-3" action="{{ route('contact.store') }}"
                    method="POST">
                    @csrf
                    <div class="flex flex-col gap-2">
                        <label for="name"> Your Name </label>
                        <input type="text" class="@error('name') is-invalid @enderror" placeholder="Name" name="name"
                            id="name">
                        @error('name')
                            <span class="invalid-feedback" role="alert">
                                <strong>{{ $message }}</strong>
                            </span>
                        @enderror
                    </div>

                    <div class="flex flex-col gap-2">
                        <label for="email"> Your Email </label>
                        <input type="text" class="@error('email') is-invalid @enderror" placeholder="Email" name="email"
                            id="email">
                        @error('email')
                            <span class="invalid-feedback" role="alert">
                                <strong>{{ $message }}</strong>
                            </span>
                        @enderror
                    </div>

                    <div class="flex flex-col gap-2">
                        <label for="message"> Your Message </label>
                        <textarea class="@error('message') is-invalid @enderror" placeholder="Message" name="message" id="message"></textarea>
                        @error('message')
                            <span class="invalid-feedback" role="alert">
                                <strong>{{ $message }}</strong>
                            </span>
                        @enderror
                    </div>

                    <div>
                        <button class="btn g-recaptcha uk-button uk-button-primary uk-button-large uk-width-1-1"
                            data-sitekey="{{ env('RECAPTCHAV3_SITEKEY') }}" data-callback='onSubmit'
                            data-action='submit' type="submit">Submit</button>
                    </div>
                </form>
            </div>
        </div>
    </div>
    <script src="https://www.google.com/recaptcha/api.js"></script>
    <script>
        function onSubmit(token) {
            document.getElementById("contact-form").submit();
        }
    </script>
</x-base-layout>

resources/views/contact_email.blade.php
<h2>Hello Admin,</h2>
You received an email from : {{ $name }}<br>
Here are the details:<br>
<b>Name:</b> {{ $name }}<br>
<b>Email:</b> {{ $email }}<br>
<b>Message:</b> {{ $user_message }}<br>
Thank You

resources/views/dashboard.blade.php
<x-app-layout>
    <x-slot name="header">
        <h2 class="font-semibold text-xl text-gray-800 leading-tight">
            {{ __('Dashboard') }}
        </h2>
    </x-slot>

    <div class="py-12">
        <div class="max-w-7xl mx-auto sm:px-6 lg:px-8">
            <div class="bg-white overflow-hidden shadow-sm sm:rounded-lg">
                <div class="p-6 bg-white border-b border-gray-200">
                    You're logged in!
                </div>
            </div>
        </div>
    </div>
</x-app-layout>

resources/views/home.blade.php
<x-base-layout>
    <form method="GET">
        @csrf
        <div class="bg-purple-100 flex-1">
            <div class="flex flex-col gap-8 max-w-7xl py-8 mx-auto ">
                <div class="flex flex-col gap-2">
                    <h1 class="text-3xl font-semibold">Welcome to Blablaflight !</h1>
                    <h2 class="text-2xl">Let's book a flight now !</h2>
                </div>
                <div class="bg-white overflow-hidden shadow-sm sm:rounded-lg">
                    <div class="p-6 bg-white border-b border-gray-200">
                        <div class="flex justify-between items-end">
                            <div class="flex flex-col w-64">
                                <label for="outbound">Your destination</label>
                                <select name="outbound" id="outbound">
                                    <option value="">-- chose your destination airport --</option>
                                    @foreach ($airports as $airport)
                                        <option @selected($airport->id == request()->outbound) value="{{ $airport->id }}">
                                            {{ $airport->country }} -
                                            {{ $airport->city }}</option>
                                    @endforeach
                                </select>
                            </div>
                            <div class="flex flex-col w-64">
                                <label for="inbound">Your origin</label>
                                <select name="inbound" id="inbound">
                                    <option value="">-- chose your origin airport --</option>
                                    @foreach ($airports as $airport)
                                        <option @selected($airport->id == request()->inbound) value="{{ $airport->id }}">
                                            {{ $airport->country }} -
                                            {{ $airport->city }}</option>
                                    @endforeach
                                </select>
                            </div>
                            <div class="flex flex-col w-64">
                                <label>Your start date</label>
                                <input type="date" id="startDateTime" name="startDateTime"
                                    value="{{ request()->startDateTime }}" min="{{ date('Y-m-d') }}">
                            </div>
                            <div class="flex flex-col w-64">
                                <label>Your end date</label>
                                <input type="date" id="endDateTime" name="endDateTime"
                                    value="{{ request()->endDateTime }}" min="{{ date('Y-m-d') }}">
                            </div>
                            <input type="hidden" name="searching" value="true">
                            <button class="btn" type="submit">Validate</button>
                        </div>
                    </div>
                </div>
            </div>
        </div>
        <div class="bg-gray-50">
            <div class="py-12  mx-auto max-w-7xl">
                @if (!empty($flights))
                    <div class="flex flex-col gap-8">
                        <div class="flex justify-between">
                            <h2 class="text-2xl">Your results - {{ $flights->total() }}
                                flight{{ $flights->total() > 0 ? 's' : '' }}</h2>
                            <select name="orderBy" onchange="this.form.submit()" name="" id="">
                                <option value="" disabled>Order by</option>
                                <option @selected('startDateTime.ASC' == request()->get('orderBy', 'startDateTime.ASC')) value="startDateTime.ASC">Start date ASC
                                </option>
                                <option @selected('startDateTime.DESC' == request()->get('orderBy', 'startDateTime.ASC')) value="startDateTime.DESC">Start date DESC
                                </option>
                                <option @selected('price.ASC' == request()->get('orderBy', 'startDateTime.ASC')) value="price.ASC">Price ASC</option>
                                <option @selected('price.DESC' == request()->get('orderBy', 'startDateTime.ASC')) value="price.DESC">Price DESC</option>
                            </select>
                        </div>
                        <div class="grid grid-cols-3 gap-x-20 gap-y-12">
                            @foreach ($flights as $flight)
                                @include('components.flight-card')
                            @endforeach
                        </div>
                        <div>
                            {{ $flights->links() }}
                        </div>
                    </div>
                @else
                    <div>
                        <h2>No flights found</h2>
                    </div>
                @endif
            </div>
        </div>
    </form>


</x-base-layout>

resources/views/singleflight.blade.php
<x-base-layout>
    <div class="bg-purple-100">
        <div class="flex flex-col gap-8 max-w-7xl py-8 mx-auto">
            <div class="flex flex-col gap-2">
                <h1 class="text-xl">Flight from <b>{{ $flight->airport_inbound->country }}</b> to
                    <b>{{ $flight->airport_outbound->country }}</b>
                </h1>
            </div>
        </div>
    </div>
    <div class="flex-1 bg-gray-50">
        <div class="flex flex-col gap-4 max-w-7xl py-8 mx-auto">
            <div class="p-6 bg-white overflow-hidden shadow-sm sm:rounded-lg">
                <div class="flex justify-between mb-4">
                    <div class="flex flex-col gap-1">
                        <p>{{ $flight->capacityLeft(1) }}</p>
                    </div>
                    <div>
                        <p class="italic text-gray-500">#{{ $flight->flightNumber }}</p>
                    </div>
                </div>
                <hr>
                <div class="flex gap-16 mt-8 mb-8">
                    <p>Departure :<br> {{ $flight->airport_inbound->city }},
                        {{ $flight->formatStartDate() }}</p>
                    <p>Arrival :<br> {{ $flight->airport_outbound->city }},
                        {{ $flight->formatEndDate() }} </p>
                    <p>Pilot :<br> {{ $flight->pilot->name }}</p>
                </div>
                <hr>
                <div class="flex justify-between mt-8">
                    <p class="text-2xl">{{ $flight->price }} € / sit</p>
                    <a class="btn" href="{{ route('bookflight', ['id' => $flight->id]) }}">Book
                        now</a>
                </div>
            </div>
        </div>
</x-base-layout>